77778e78f8e390b978dee54a24849334da7e9972
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
18     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
19       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
20     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
21       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
22       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
23         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
24       fi
25     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
26       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_fdio.yaml"
27     else
28       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
29     fi
30     SDN_IMAGE=opendaylight
31   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
32     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
33     SDN_IMAGE=opendaylight
34   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
35     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
36       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
37     else
38       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
39     fi
40     SDN_IMAGE=onos
41   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
42     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
43     exit 1
44   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
45     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
46     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
47       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
48     fi
49     SDN_IMAGE=opendaylight
50   else
51     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
52     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
53     exit 1
54   fi
55
56
57
58   # Make sure the correct overcloud image is available
59   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
60       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
61       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
62       exit 1
63   fi
64
65   echo "Copying overcloud image to Undercloud"
66   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
67   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
68
69   # Install ovs-dpdk inside the overcloud image if it is enabled.
70   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
71     # install dpdk packages before ovs
72     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
73
74     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
75       cat << EOF > vfio_pci.modules
76 #!/bin/bash
77 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
78 EOF
79
80       cat << EOF > uio_pci_generic.modules
81 #!/bin/bash
82 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
83 EOF
84
85       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
86                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
87                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
88                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
89                                                -a overcloud-full.qcow2
90
91       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
92         sudo sed -i '/NeutronOVSDataPathType:/c\  NeutronOVSDataPathType: netdev' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
93         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
94                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
95                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
96                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
97                                                  -a overcloud-full.qcow2
98       fi
99
100 EOI
101
102   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
103     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
104     exit 1
105   fi
106
107   if [ "$debug" == 'TRUE' ]; then
108     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
109   fi
110
111   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
112   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
113     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
115                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
116                                                   -a overcloud-full.qcow2
117 EOI
118   fi
119
120   # Set ODL version accordingly
121   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
122     case "${deploy_options_array['odl_version']}" in
123       beryllium) odl_version=''
124               ;;
125       boron)  odl_version='boron'
126               ;;
127       carbon) odl_version='master'
128               ;;
129       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
130          exit 1
131          ;;
132     esac
133
134     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
135       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
136                                                --run-command "yum -y install /root/${odl_version}/*" \
137                                                -a overcloud-full.qcow2
138 EOI
139   fi
140
141   # Add performance deploy options if they have been set
142   if [ ! -z "${deploy_options_array['performance']}" ]; then
143
144     # Remove previous kernel args files per role
145     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Compute-kernel_params.txt"
146     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Controller-kernel_params.txt"
147
148     # Push performance options to subscript to modify per-role images as needed
149     for option in "${performance_options[@]}" ; do
150       echo -e "${blue}Setting performance option $option${reset}"
151       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "dataplane=${deploy_options_array['dataplane']} bash build_perf_image.sh $option"
152     done
153
154     # Build IPA kernel option ramdisks
155     ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" <<EOI
156 /bin/cp -f /home/stack/ironic-python-agent.initramfs /root/
157 mkdir -p ipa/
158 pushd ipa
159 gunzip -c ../ironic-python-agent.initramfs | cpio -i
160 if [ ! -f /home/stack/Compute-kernel_params.txt ]; then
161   touch /home/stack/Compute-kernel_params.txt
162   chown stack /home/stack/Compute-kernel_params.txt
163 fi
164 /bin/cp -f /home/stack/Compute-kernel_params.txt tmp/kernel_params.txt
165 echo "Compute params set: "
166 cat tmp/kernel_params.txt
167 /bin/cp -f /root/image.py usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.py
168 /bin/cp -f /root/image.pyc usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.pyc
169 find . | cpio -o -H newc | gzip > /home/stack/Compute-ironic-python-agent.initramfs
170 chown stack /home/stack/Compute-ironic-python-agent.initramfs
171 if [ ! -f /home/stack/Controller-kernel_params.txt ]; then
172   touch /home/stack/Controller-kernel_params.txt
173   chown stack /home/stack/Controller-kernel_params.txt
174 fi
175 /bin/cp -f /home/stack/Controller-kernel_params.txt tmp/kernel_params.txt
176 echo "Controller params set: "
177 cat tmp/kernel_params.txt
178 find . | cpio -o -H newc | gzip > /home/stack/Controller-ironic-python-agent.initramfs
179 chown stack /home/stack/Controller-ironic-python-agent.initramfs
180 popd
181 /bin/rm -rf ipa/
182 EOI
183
184     # set NIC heat params and resource registry
185     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
186 if [ -n "${private_network_compute_interface}" ]; then
187   sudo sed -i '/ComputeTenantNIC:/c\  ComputeTenantNIC: '${private_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
188 fi
189 if [ -n "${private_network_controller_interface}" ]; then
190   sudo sed -i '/ControllerTenantNIC:/c\  ControllerTenantNIC: '${private_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
191 fi
192 # TODO: PublicNIC is not used today, however, in the future, we'll bind public nic to DPDK as well for certain scenarios. At that time,
193 # we'll need to make sure public network is enabled.
194 if [ -n "${public_network_compute_interface}" ]; then
195   sudo sed -i '/ComputePublicNIC:/c\  ComputePublicNIC: '${public_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
196 fi
197 if [ -n "${public_network_controller_interface}" ]; then
198   sudo sed -i '/ControllerPublicNIC:/c\  ControllerPublicNIC: '${public_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
199 fi
200 EOI
201
202     echo -e "${blue}INFO: Including /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml ${reset}"
203     if [ "$debug" == 'TRUE' ]; then
204       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "cat /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
205     fi
206     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
207   fi
208
209   # check if ceph should be enabled
210   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
211     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
212   fi
213
214   #DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
215   DEPLOY_OPTIONS+=" -e network-environment.yaml"
216
217
218   # get number of nodes available in inventory
219   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
220   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
221
222   # check if HA is enabled
223   if [[ "$ha_enabled" == "True" ]]; then
224     if [ "$num_control_nodes" -lt 3 ]; then
225       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
226       exit 1
227     else
228      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
229      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
230      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
231     fi
232   else
233     if [ "$num_control_nodes" -lt 1 ]; then
234       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
235       exit 1
236     fi
237   fi
238
239   if [ "$num_compute_nodes" -le 0 ]; then
240     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
241     exit 1
242   else
243     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
244     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
245   fi
246
247   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
248
249   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
250   if [[ "$virtual" == "TRUE" ]]; then
251      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
252   fi
253
254   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
255
256   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
257
258   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
259 if [ "${deploy_options_array['tacker']}" == 'False' ]; then
260     sed -i '/EnableTacker:/c\  EnableTacker: false' ${ENV_FILE}
261 fi
262
263 # Create a key for use by nova for live migration
264 echo "Creating nova SSH key for nova resize support"
265 ssh-keygen -f nova_id_rsa -b 1024 -P ""
266 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
267 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
268 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
269 mv -f opnfv-environment-new.yaml ${ENV_FILE}
270
271 source stackrc
272 set -o errexit
273 # Workaround for APEX-207 where sometimes swift proxy is down
274 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
275   sudo systemctl restart openstack-swift-proxy
276 fi
277 echo "Uploading overcloud glance images"
278 openstack overcloud image upload
279
280 echo "Configuring undercloud and discovering nodes"
281 openstack baremetal import --json instackenv.json
282
283 bash -x set_perf_images.sh ${performance_roles[@]}
284 if [[ -z "$virtual" ]]; then
285   openstack baremetal introspection bulk start
286   if [[ -n "$root_disk_list" ]]; then
287     openstack baremetal configure boot --root-device=${root_disk_list}
288   else
289     openstack baremetal configure boot
290   fi
291 else
292   openstack baremetal configure boot
293 fi
294
295 echo "Configuring flavors"
296 for flavor in baremetal control compute; do
297   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
298   if openstack flavor list | grep \${flavor}; then
299     openstack flavor delete \${flavor}
300   fi
301   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
302   if ! openstack flavor list | grep \${flavor}; then
303     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
304   fi
305 done
306 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
307 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
308 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
309 echo "Configuring nameserver on ctlplane network"
310 dns_server_ext=''
311 for dns_server in ${dns_servers}; do
312   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
313 done
314 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
315 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
316 echo "Executing overcloud deployment, this should run for an extended period without output."
317 sleep 60 #wait for Hypervisor stats to check-in to nova
318 # save deploy command so it can be used for debugging
319 cat > deploy_command << EOF
320 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
321 EOF
322 EOI
323
324   if [ "$interactive" == "TRUE" ]; then
325     if ! prompt_user "Overcloud Deployment"; then
326       echo -e "${blue}INFO: User requests exit${reset}"
327       exit 0
328     fi
329   fi
330
331   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
332 source stackrc
333 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
334 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
335   $(typeset -f debug_stack)
336   debug_stack
337   exit 1
338 fi
339 EOI
340
341   # Configure DPDK
342   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
343     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
344 source stackrc
345 set -o errexit
346 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
347 echo "Running DPDK test app on \$node"
348 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
349 set -o errexit
350 sudo dpdk_helloworld --no-pci
351 sudo dpdk_nic_bind -s
352 EOF
353 done
354 EOI
355   fi
356
357   if [ "$debug" == 'TRUE' ]; then
358       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
359 source overcloudrc
360 echo "Keystone Endpoint List:"
361 openstack endpoint list
362 echo "Keystone Service List"
363 openstack service list
364 cinder quota-show \$(openstack project list | grep admin | awk {'print \$2'})
365 EOI
366   fi
367 }